#!/usr/bin/perl
# Demo program to list mail aliases, and either create or delete one

use Frontier::Client;
use Data::Dumper;

chop($url = `cat url.txt`);
eval {
  $server = Frontier::Client->new('url' => $url);
  };
$@ && die "Failed to create server : $@";

$conf = $server->call("sendmail::get_sendmailcf");
$afile = $server->call("sendmail::aliases_file", $conf);
$aliases = $server->call("sendmail::list_aliases", $afile);
print "Found ",scalar(@$aliases)," mail aliases\n";

($already) = grep { $_->{'name'} eq 'foobar' } @$aliases;
if ($already) {
	print "Alias foobar -> $already->{'values'}->[0] exists, deleting it\n";
	$server->call("sendmail::delete_alias", $already);
	print "Done deletion\n";
	}
else {
	print "Adding alias foobar\n";
	$alias = { 'name' => 'foobar',
		   'enabled' => 1,
		   'values' => [ "jcameron\@webmin.com" ],
		 };
	$server->call("sendmail::create_alias", $alias, $afile);
	}

