#!/usr/bin/perl
# Create a new Unix user

use Frontier::Client;
use Data::Dumper;

$username = "wibble";
$password = "smeg";
$shell = "/bin/bash";
$groupname = "users";
$real = "XML Test User";

chop($url = `cat url.txt`);
eval {
  $server = Frontier::Client->new('url' => $url);
  };
$@ && die "Failed to create server : $@";

# Make sure the user doesn't exist yet
$users = $server->call("useradmin::list_users");
($clash) = grep { $_->{'user'} eq $username } @$users;
if ($clash) {
	die "A user named $username already exists";
	}

# Pick a UID
%uids_used = map { $_->{'uid'}, 1 } @$users;
for($uid=500; $uids_used{$uid}; $uid++) { }

# Find the correct group ID
$groups = $server->call("useradmin::list_groups");
($group) = grep { $_->{'group'} eq $groupname } @$groups;
$group || die "Failed to find group named $group";

# Encrypt the password
$encpass = $server->call("useradmin::encrypt_password", $password);

# Find a good home directory
$home = $server->call("useradmin::auto_home_dir", "/home",
		      $username, $groupname);

# Create the user object
$user = { 'user' => $username,
	  'uid' => $uid,
	  'gid' => $group->{'gid'},
	  'pass' => $encpass,
	  'home' => $home,
	  'shell' => $shell,
	  'real' => $real };
$server->call("useradmin::create_user", $user);
print "Created user $username with uid $uid and gid $group->{'gid'}\n";

# Create home dir
$server->call("useradmin::create_home_directory", $user);
$uf = $server->call("useradmin::get_skel_directory", $user, $groupname);
$server->call("useradmin::copy_skel_files", $uf, $home,
					    $user->{'uid'}, $user->{'gid'});
print "Create home directory $user->{'home'}\n";

